#include "smtp.h"


char *pcMonths[12]={"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

char *smtp_alltrim(char *lcChar)
   {
   char *lcXXX;

   if (!lcChar)
      return lcChar;

   // skip space at the beginning 
   lcXXX=lcChar+j_strlen(lcChar)-1;
   while (*lcChar == ' ' && lcChar<=lcXXX)
         {
         *lcChar = '\0';
         lcChar++;
         }

    // skip space at the end  
    lcXXX=lcChar;
    while (lcChar[-1] == ' ' && lcChar>=lcXXX)
          {
          *lcChar = '\0';
          lcChar--;
          }
    return lcChar;
    }


char *smtp_lgstrim(char *lcChar)
   {
   char *lcXXX;

   if (lcChar==NULL)
      return NULL;

   // skip < at the beginning 
   lcXXX=lcChar+j_strlen(lcChar)-1;
   while (*lcChar != '<' && lcChar<=lcXXX)
         {
         lcChar++;
         }

   if (*lcChar == '<')
      {
      *lcChar = '\0';
      }

   lcXXX=lcChar=lcChar+1;

   // skip > at the end  
   lcXXX=lcChar+j_strlen(lcChar)-1;
   while (lcXXX[0] != '>' && lcXXX>=lcChar)
         {
         lcXXX--;
         }
   
   if (*lcXXX == '>')
      {
      *lcXXX = '\0';
      }
   return lcChar;
   }



xmlnode out_SetReply(xmlnode loNew, xmlnode loOld)
   {
   char *lcId;
   xmlnode addresses,address,addressesN,addressN;

   xmlnode_put_attrib(loNew,"from",xmlnode_get_attrib(loOld,"to"));
   xmlnode_put_attrib(loNew,"to",xmlnode_get_attrib(loOld,"from"));
   if ((lcId=xmlnode_get_attrib(loOld,"id")))
      xmlnode_put_attrib(loNew,"id",lcId);


   // JEP-0033 stanzas
   if ((addresses=xmlnode_get_tag(loOld,"addresses?xmlns=http://jabber.org/protocol/address"))) 
      {
      // put adresses element to new node
      xmlnode_put_attrib(addressesN=xmlnode_insert_tag(loNew,"addresses"),"xmnls","http://jabber.org/protocol/address");

       // copy all childs elements to new node
      for (address = xmlnode_get_firstchild(addresses); address != NULL; address = xmlnode_get_nextsibling(address))
          {
          xmlnode_put_attrib(addressN=xmlnode_insert_tag(addressesN,"address"),"jid",xmlnode_get_attrib(address,"jid"));
          xmlnode_put_attrib(addressN,"type",xmlnode_get_attrib(address,"type"));
          }
      }

   return loNew;
   }



char *smtp_CMonth(int liMonth)
   {
   return pcMonths[liMonth];
   }


char *smtp_itoa(int liNumber)
   {
   static char lcItoA[17];
   snprintf(lcItoA, sizeof(lcItoA), "%i\0",liNumber);
   return (char *)lcItoA;
   }


void smtp_ReplyError(smtpp par, jpacket loOrig, const char *lcNodeName, const char *lcBody, int liError)
   {
   xmlnode x501, xError;

   x501= out_SetReply(xmlnode_new_tag(lcNodeName),loOrig->x);
   xmlnode_put_attrib(x501,"type","error");

   xmlnode_put_attrib(xError=xmlnode_insert_tag(x501,"error"),"code",smtp_itoa(liError));
   xmlnode_insert_cdata(xError,lcBody,-1);

   deliver(dpacket_new(xmlnode_dup(x501)),par->sin->i);
   xmlnode_free(x501);
   }


void smtp_StatsInc(smtpp par, const char *lcStatName)
   {
   smtpi sin=par->sin;
   int liValue=1;

   liValue+=j_atoi(xmlnode_get_attrib(sin->statistics,lcStatName),0);
   xmlnode_put_attrib(sin->statistics,lcStatName,smtp_itoa(liValue));
   xmlnode2file(sin->stat_file,sin->statistics);
   }


char *smtp_GetSMTPAddress(char *lcJID)
   {
   char *host;

   host = strstr(lcJID,"@");
   *host = '\0';
   host = strstr(lcJID,"%");
   *host = '@';
   ++host;
   return host;
   }



char *smtp_ToUTF8(pool p, char *lcText,const char *charmap)
   {
   int liIn,liOut;
   char *lcRet;
//   iconv_t iconv_obj;

   liIn=j_strlen(lcText);
   liOut=2*liIn;
   log_debug(ZONE,"xxxxxxxxxxxxxxx -   %i %i\r\n",liIn,liOut);

   lcRet = (char*)pmalloco(p, liOut);


/*
   iconv_obj = iconv_open("UTF-8", charmap);

   log_debug(ZONE,"xxxxxxxxxxxxxxx -   %i \r\n",(int) iconv_obj);
   if ((iconv_obj == (iconv_t) -1))
      {
//           log_notice(ZONE, "[YAHOO]: Error - iconv_open returned %d",errno);
//             strncpy(result, tmp, outbytes);
      }
   else
      {
      iconv(iconv_obj, lcText, &liIn, lcRet, &liOut);
      iconv_close(iconv_obj);
      }
*/
   log_debug(ZONE,"xxxxxxxxxxxxxxx -   %s \r\n",lcRet);
   return lcRet;
   }


void fromQP(char *string, void *byteStream)
   {
   char *binPtr = (char *)byteStream, lcChar;
   int strSize = strlen(string);
   int i = 0, j = 0;
   
   for(i = 0, j = 0; i < strSize; i++, j++)
      {
      lcChar=string[i]; // read char
      if (lcChar== '=') // escaped char
         {
         if (string[i+1]=='\r' || string[i+1]=='\n')
            {
//            binPtr[j] = ' ';
            j--;
            i=i+(((string[i+1]=='\r' && string[i+2]=='\n'))?2:1);
            }
         else
            {
            binPtr[j] = (string[i+1]-(string[i+1]<65?48:55))*16+(string[i+2]-(string[i+2]<65?48:55));
            i+=2;
            }
         }
      else
         binPtr[j] = lcChar;

      }
   binPtr[j] = '\0';

   }

int toQP_addsoftline(char *lcLine, int liCurrent, int *liEnter)
   {
   lcLine[liCurrent+1] = '=';
   lcLine[liCurrent+2] = 13;
   lcLine[liCurrent+3] = 10;
   *liEnter=0;
   return liCurrent+2;
   }


void toQP(char *string, void *byteStream, int liSoftLines)
   {
   char *binPtr = (char *)byteStream, lcChar;
   int strSize = strlen(string);
   int i = 0, j = 0, liEnter=0,liChar, liASCII;

   for(i = 0, j = 0; i < strSize; i++, j++)
      {
      lcChar=string[i]; // read char

      if ((lcChar>=33 && lcChar<=60) || (lcChar>=62 && lcChar<=126) || lcChar==32)
         liASCII=1;
      else
         liASCII=3;

      if (liEnter+liASCII>60 && liSoftLines==1)
         j=toQP_addsoftline(binPtr+j,j,&liEnter);

      if (liASCII==1) // US-ASCII
         {      
         binPtr[j] = lcChar;
         liEnter++;
         }
      else
         {      
         binPtr[j] = '=';
         binPtr[j+1] = (liChar= (lcChar<0?lcChar+256:lcChar)/16) +(liChar<10?48:55);
         binPtr[j+2] = (liChar=fmod((lcChar<0?lcChar+256:lcChar),16))+(liChar<10?48:55);
         j+=2;
         liEnter+=2;
         }

      }
   binPtr[j] = '\0';
   }

